#!../../bin/sh
devs=`grep -H ide-disk /proc/ide/hd*/driver | cut -f 4 -d "/"`
    

echo "Drives found:"
echo

while [ "$flag" != "done" ]; do
    count=0
    for i in $devs; do
	let "count=$count+1"	
	eval "dev$count=$i"
	
	echo "$count) $i"
	echo "-----------"	
	cat /proc/ide/$i/model
	blocks=`cat /proc/ide/$i/capacity`
	bytes=`echo "$blocks 512 * p" | dc`
	eval "size$count=$bytes"
	echo "Size: $bytes bytes"
    done

    if [ $count -eq 0 ]; then
	echo "No drives found."
	exit
    fi


    echo -n "Please choose a drive (1-$count) for more information (Q to quit): "
    read choice
    case $choice in
	[Qq]*)
	    echo "Stopping."
	    exit
	;;
	*)
	    eval device=\$dev$choice
	    eval bytes=\$size$choice
	    if [ "$device" != "" ]; then
		flag="done"
	    fi
	;;
    esac
done

cmdline="shred -x -v"
# --size=$bytes 

echo
echo "With what level of confidence would you like to erase this disk?"
echo
echo "1)  Zero disk only. Slow, only effective against non-hackers."
echo "2)  One random pass. A little slower, effective against most."
echo "3)  3 \"binary overwrite\" passes. Even slower, likely as secure as you need."
echo "4)  10 passes, some structured. Very slow. Almost certainly secure."
echo "5)  25 structured passes. Unbearably slow, but probably secure against the NSA."
echo

flag=""
while [ "$flag" != "done" ]; do
  echo -n "Level (1-5,Q)? "
  read level
  case $level in
    1)
	cmdline="$cmdline -n 0 -z"
	flag="done"
    ;;
    2)
	cmdline="$cmdline -n 1 -z"
	flag="done"
    ;;
    3)
	cmdline="$cmdline -n 3"
	flag="done"
    ;;
    4)
	cmdline="$cmdline -n 10 -z"
	flag="done"
    ;;
    5)
	flag="done"
    ;;
    [Qq]*)
	echo "Stopping."
	exit
    ;;
    *)
    ;;

    esac
done

cmdline="$cmdline /dev/$device"
echo "About to run the command: $cmdline"
echo "WARNING: THIS WILL COMPLETELY ERASE THE DISK /dev/$device."
flag=""

while [ "$flag" != "done" ]; do
echo -n "Are you absolutely sure you want to do this? (Y/N) "
read final
case $final in
  [Yy]*)
    flag="done"
    echo "Ok then. Don't say I didn't warn you."
    eval $cmdline
    echo
    echo "Finished erasing /dev/$device."
  ;;
  [Nn]*)
    flag="done"
    echo "Stopping."
    exit
  ;;
  *)
    echo "I'm looking for \"yes\" or \"no\" here."
  ;;
esac
done

echo "Done."
